<template>
  <div class="list-group w-100 radio-facet" role="group" :aria-labelledby="myTitleId">
    <facet-title
      :title="header"
      :tooltip="toolTipTitle"
      :title-id="myTitleId"
    />
    <div class="list-group-item list-group-item-action d-flex justify-content-between align-items-center">
      {{ property }}
      <span class="ml-2 d-flex flex-wrap">
        <div class="custom-control custom-radio" v-for="(id, index) in optionIds">
          <input type="radio" :id="`${header}_${id}`" :value="id" :name="header" class="custom-control-input" @click="onChange(id)" :checked="option === id">
          <label class="custom-control-label" :for="`${header}_${id}`">{{ optionLabels[index] }}</label>
        </div>
      </span>
    </div>
  </div>
</template>

<script>
import FacetTitle from "../facets/FacetTitle.vue";
export default {
  name: "RadioFacet",
  components: {FacetTitle},
  props: {
    config: Object,
    property: String,
    optionIds: {
      type: Array,
      default: ['true', 'false']
    },
    optionLabels: {
      type: Array
    },
    initialOption: String,
    change: Function
  },
  data() {
    return {
      id: '',
      option: this.initialOption,
      header: this.i18n.global.t(`message.datasetFacets.facets.${this.config.id.toLowerCase()}`),
      toolTipTitle: this.i18n.global.t(`message.helpIcon.${this.config.id.toLowerCase()}`),
      yes: this.i18n.global.t('message.metadata.yes'),
      no: this.i18n.global.t('message.metadata.no')
    };
  },
  computed: {
    myId() {
      // Use Vue generated uid to give each facet a unique id
      return `facet-${this.id}`;
    },
    myTitleId() {
      // Use Vue generated uid to give each facet a unique id
      return `facet-title-${this.id}`;
    }
  },
  methods: {
    onChange(id) {
      this.option = id;
      console.log("onChange", id)
      this.change(id);
    }
  },
  watch: {
    initialOption(value) {
      this.option = value;
    }
  },
  mounted() {
    this.id = this._uid; // eslint-disable-line
  },
}
</script>

